<?php

/** 
 ** 
 **              ██╗ █████╗ ██████╗ ██╗██╗      █████╗ ██╗  ██╗    ███╗   ███╗██╗   ██╗███████╗██╗     ██╗███╗   ███╗             
 **              ██║██╔══██╗██╔══██╗██║██║     ██╔══██╗██║  ██║    ████╗ ████║██║   ██║██╔════╝██║     ██║████╗ ████║             
 **              ██║███████║██║  ██║██║██║     ███████║███████║    ██╔████╔██║██║   ██║███████╗██║     ██║██╔████╔██║             
 **         ██   ██║██╔══██║██║  ██║██║██║     ██╔══██║██╔══██║    ██║╚██╔╝██║██║   ██║╚════██║██║     ██║██║╚██╔╝██║             
 **         ╚█████╔╝██║  ██║██████╔╝██║███████╗██║  ██║██║  ██║    ██║ ╚═╝ ██║╚██████╔╝███████║███████╗██║██║ ╚═╝ ██║             
 **          ╚════╝ ╚═╝  ╚═╝╚═════╝ ╚═╝╚══════╝╚═╝  ╚═╝╚═╝  ╚═╝    ╚═╝     ╚═╝ ╚═════╝ ╚══════╝╚══════╝╚═╝╚═╝     ╚═╝             
 **                                                                                                                               
 **  █████╗ ███╗   ███╗ █████╗ ███╗   ██╗ █████╗ ██╗  ██╗       ██╗       ██████╗ ███████╗██████╗  █████╗ ██████╗  █████╗ ██████╗ 
 ** ██╔══██╗████╗ ████║██╔══██╗████╗  ██║██╔══██╗██║  ██║       ██║       ██╔══██╗██╔════╝██╔══██╗██╔══██╗██╔══██╗██╔══██╗██╔══██╗
 ** ███████║██╔████╔██║███████║██╔██╗ ██║███████║███████║    ████████╗    ██████╔╝█████╗  ██████╔╝███████║██║  ██║███████║██████╔╝
 ** ██╔══██║██║╚██╔╝██║██╔══██║██║╚██╗██║██╔══██║██╔══██║    ██╔═██╔═╝    ██╔══██╗██╔══╝  ██╔══██╗██╔══██║██║  ██║██╔══██║██╔══██╗
 ** ██║  ██║██║ ╚═╝ ██║██║  ██║██║ ╚████║██║  ██║██║  ██║    ██████║      ██████╔╝███████╗██║  ██║██║  ██║██████╔╝██║  ██║██████╔╝
 ** ╚═╝  ╚═╝╚═╝     ╚═╝╚═╝  ╚═╝╚═╝  ╚═══╝╚═╝  ╚═╝╚═╝  ╚═╝    ╚═════╝      ╚═════╝ ╚══════╝╚═╝  ╚═╝╚═╝  ╚═╝╚═════╝ ╚═╝  ╚═╝╚═════╝ 
 **                                                                                                                     
 ** Semoga Allah Ta'ala TIDAK memberkahi perniagaan orang yang mengutip kode program di plugin ini 
 ** "Tidak dihalalkan harta seorang muslimin kecuali yang diberikan dari ketulusan hatinya yang dalam."
 ** ( HR Al Baihaqi, Ahmad, Ad-Daraquthni - Dishahihkan oleh Al-Albani )
 ** 
***/

class WFCO_Wabot_Contact_Group_Action extends WFCO_Call {

    private static $instance = null;

    public function __construct() {
        $this->required_fields = array( 'access_token', 'number', 'name', 'group_id', 'action' );
    }

    public static function get_instance() {
        if ( null === self::$instance ) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function process() {
        if ( false === $this->check_fields( $this->data, $this->required_fields ) ) {
            return $this->show_fields_error();
        }

        $url = "https://painel.wabot.app.br/api/contact_group_action";
        //$url = "https://webhook.site/daf2873c-1ddc-40e8-8820-cd7d38afeb98";

        $headers = array(
            'Content-Type' => 'application/json',
        );

        $req_params = array(
            'number'   => str_replace( ['+','-',' '], '', $this->data['number'] ),
            'name' => $this->data['name'],
            'access_token' => $this->data['access_token'],
            'action'  => $this->data['action'],
            'group_id' => $this->data['group_id'],
        );

        return $this->make_wp_requests( $url, wp_json_encode( $req_params ), $headers, BWF_CO::$POST );
    }
}

return 'WFCO_Wabot_Contact_Group_Action';

